#include "graphic.h"


/* 
 * Fonctions pour grer le chargement des maps
 */

void
Load_Map(const char *map_file)
{
  int a = 0, ch;
  FILE * in;
  
  map = (char *) malloc ((NB_COL * NB_LIG) * sizeof(char));

  if(!(in = fopen(map_file,"r")))
    { 
      perror(map_file); 
      exit(1); 
    }
  while(!feof(in))
    { 
      ch=getc(in); 
      if(ch!='\n') map[a++]=ch; 
    }
  fclose(in);

  printf("Map charge en mmoire\n");
}

void 
Draw_Map() // le vrai load qui dessine la map
{
  FL_OBJECT *obj;
  
  int ligne, colonne;
  
  int input = 0;
  
  fl_freeze_form(fd_Main->main);
  
  for(ligne = 0; ligne < NB_LIG; ligne++){
    for(colonne = 0; colonne < NB_COL; colonne++, input++){
      obj = fd_Main->Carre[colonne+(ligne*NB_LIG)];
      switch(map[colonne+(ligne*NB_LIG)])
	{
	case '0': // dja fait 
	  break;
	case '1': fl_set_pixmap_file(obj, WALL_PIXMAP);     break;
	case '2': 
	  fl_set_pixmap_file(obj, DROID_PIXMAP);
	  pos_inits[input] = colonne+(ligne*NB_COL);
	  break;
	case '3': fl_set_pixmap_file(obj, EXIT_PIXMAP);     break;
	case '4': fl_set_pixmap_file(obj, TREASURE_PIXMAP); break; 
	}
    }
  }
  
  fl_unfreeze_form(fd_Main->main);

  FLAG_LOADED = 1;
}

void 
Explorer()
{ 
  printf("On lance l'exploration\n");

  // initialisation de la mmoire du robot
  memory = (char *) calloc ((NB_COL * NB_LIG), sizeof(char));  

  // condition initiale
  current_position = 1;
  last_position = current_position;
  direction = TOWARD_DOWN;

  while (map[current_position] != '3') {
    Explorer_Algo();
    Draw_new_position();
    Draw_memory_position(current_position);
  }

  printf("Sortie trouve\n");
}

void Draw_new_position(void)
{
  FL_OBJECT *obj;
  
  fl_freeze_form(fd_Main->main);
  if(pthread_mutex_trylock(&screenlock) != 0) { 

    obj = fd_Main->Carre[last_position];
    fl_set_pixmap_file(obj, FLOOR_PIXMAP);
    
    obj = fd_Main->Carre[current_position];
    fl_set_pixmap_file(obj, DROID_PIXMAP);
  
    last_position = current_position;
    pthread_mutex_unlock(&screenlock);
  }
  fl_unfreeze_form(fd_Main->main);
}

void Draw_memory_position(int new_position)
{
  FL_OBJECT *obj;
  
  fl_freeze_form(fd_Main->main);
  
  obj = fd_Main->Mem[new_position];
  
  switch(map[new_position])
    {
    case '0': fl_set_pixmap_file(obj, INODE_PIXMAP);   break;
    case '3': fl_set_pixmap_file(obj, INODE_EXIT);     break;
    case '4': fl_set_pixmap_file(obj, INODE_TREASURE); break;
    }
  fl_unfreeze_form(fd_Main->main);
}

