#include "graphic.h"
#include "network.h"

#define DEBUG if(0) fprintf

void *network(void *arg)
{
  fd_set master;   
  fd_set read_fds; 
  struct sockaddr_in myaddr;
  struct sockaddr_in remoteaddr;
  int fdmax;
  int listener;
  int newfd;
  char buf[256];
  int nbytes;
  int yes=1;
  int addrlen;
  int i;

  char temp;          // case lu  retourner  un client
  char position;      // position d'un robot
  int pos_init = 0;

  FD_ZERO(&master);
  FD_ZERO(&read_fds);

  // Le listener
  if ((listener = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
    perror("socket");
    exit(1);
  }

  // Pour ne pas avoir le message "address already in use"
  if (setsockopt(listener, SOL_SOCKET, SO_REUSEADDR, &yes, sizeof(int)) == -1) {
    perror("setsockopt");
    exit(1);
  }

  // Bind
  myaddr.sin_family = AF_INET;
  myaddr.sin_addr.s_addr = INADDR_ANY;
  myaddr.sin_port = htons(PORT);
  memset(&(myaddr.sin_zero), '\0', 8);
  if (bind(listener, (struct sockaddr *)&myaddr, sizeof(myaddr)) == -1) {
    perror("bind");
    exit(1);
  }

  // Listen
  if (listen(listener, 10) == -1) {
    perror("listen");
    exit(1);
  }

  // On ajoute le listener au master 
  FD_SET(listener, &master);


  fdmax = listener; 

  // Boucle principale
  for(;;) {
    read_fds = master;
    if (select(fdmax+1, &read_fds, NULL, NULL, NULL) == -1) {
      perror("select");
      exit(1);
    }

    // On parcours toutes les connexions existantes
    for(i = 0; i <= fdmax; i++) {
      if (FD_ISSET(i, &read_fds)) { 
	if (i == listener) {
	  // Une nouvelle connection
	  socklen_t *test;
	  addrlen = sizeof(remoteaddr);
	  test =(socklen_t *) addrlen;
	  if ((newfd = accept(listener, (struct sockaddr *)&remoteaddr, (socklen_t * )&addrlen )) == -1) { 
	    perror("accept");
	  } else {
	    FD_SET(newfd, &master); // On l'ajoute au master
	    if (newfd > fdmax) {
	      fdmax = newfd;
	    }
	    printf("Serveur: Nouvelle connection depuis %s "
		   "socket %d\n", inet_ntoa(remoteaddr.sin_addr), newfd);
	  }
	} else {
	  // Des donnes depuis le client 
	  if ((nbytes = recv(i, buf, sizeof(buf), 0)) <= 0) {
	    
	    // Erreur ou deconnexion
	    if (nbytes == 0) {
	      // Deconnexion
	      printf("Serveur: socket %d s'est deconnecte\n", i);
	    } else {
	      perror("recv");
	    }
	    close(i); 
	    FD_CLR(i, &master); // On l'enleve du master
	  } else {
	    
	    // Un petit protocole fait maison
	    if (strcmp(buf, CONNECT) == 0) {
	      //write(i, pos_inits + pos_init, sizeof(pos_inits[0] ));
	      //pos_init++;
	    }
	    else if (strcmp(buf, WRITE) == 0) { // on recup la case  MAJ
	      read(i, &position, sizeof(char));
	      printf("On a recu la position: %d\n", position);
	      //Draw_new_position((int)position);
	      //Draw_memory_position((int)position);
	      pthread_mutex_lock(&screenlock);
	      current_position = position;
	      pthread_mutex_unlock(&screenlock);
	    }
	    else if (strcmp(buf, READ) == 0) { // on lit une case de map
	      read(i, &temp, sizeof(temp));
	      DEBUG(stderr, "position :%d\n", temp); 
	      write(i, map + temp, sizeof(map[0]));
	      DEBUG(stderr, "resultat :%c\n", map[temp]); 
	    }
	  }
	}
      }
    }
  }
}









